BEGIN{unshift @INC, "../../lib", "./lib";}

$host = shift || "localhost";

print "1..27\n";
use Msql;

#You may connect in two steps: (1) Connect and (2) SelectDB...
( $dbh = Connect Msql $host)
    and print("ok 1\n") 
    or die "not ok 1: $Msql::db_errstr
-- please start server with `msqld &' on `$host'\n";

( $dbh->SelectDB("test") ) 
    and print("ok 2\n") 
    or die "not ok 2: $Msql::db_errstr 
-- please run `msqladmin create test'\n";

#Or you may call connect with two arguments, the first being the
#host, and the second being the DB

( $dbh = Connect Msql($host,"test") )
    and print("ok 3\n") 
    or die "not ok 3: $Msql::db_errstr\n";

#First we create two tables that are certainly not there
($lasttable) =  (sort $dbh->ListTables)[-1];
$lasttable = "TABLE00" unless $lasttable;
push @tables, ++$lasttable;
push @tables, ++$lasttable;


$dbh->Query("create table $tables[0] (one char(32), two char(32),
  three char (32))");

$dbh->Query("create table $tables[1] (one char(32),
  two char(32) not null, three char (32))");

$dbh->Insert($tables[0],qw(Anna Franz Otto));
$dbh->Insert($tables[0],qw(Sabine Thomas Pauline));
$dbh->Insert($tables[0],qw(Jane Paul Jah));
$dbh->Insert($tables[1],qw(Henry Francis James));
$dbh->Insert($tables[1],qw(Cashrel Beco Lotic));


$sth = $dbh->Query("select * from $tables[0]");

($sth->{RESULT} > 0) and print("ok 4\n") or print("not ok 4\n");
($sth->{NUMFIELDS} == 3) and print ("ok 5\n") or print("not ok 5\n");
(@{$sth->{NAME}} == $sth->{NUMFIELDS}) 
    and print ("ok 6\n") or print("not ok 6\n");
${$sth->{TABLE}}[0] eq ${$sth->{TABLE}}[1]
    and print ("ok 7\n") or print("not ok 7\n");
${$sth->{TABLE}}[1] eq ${$sth->{TABLE}}[2] 
    and print ("ok 8\n") or print("not ok 8\n");

&CHAR_TYPE == ${$sth->{TYPE}}[0] 
    and print ("ok 9\n") or print("not ok 9\n");
$rowcnt=0;
while (@row = $sth->FetchRow()){
    $rowcnt++;
}
$sth->DataSeek(0);
while (@row = $sth->FetchRow()){
    $rowcnt++;
}
($rowcnt/2 == $sth->{NUMROWS})
    and print ("ok 10\n") or print("not ok 10\n");

$sth = $dbh->Query("select * from $tables[1]");

${$sth->{IS_NOT_NULL}}[1] == 1 
    and print ("ok 11\n") or print("not ok 11\n");

( $dbh = Connect Msql($host,"test") )
    and print("ok 12\n") 
    or print "not ok 12: $Msql::db_errstr\n";

($sth1 = Query $dbh "select * from $tables[0]")
     or warn "Query had some problem: $Msql::db_errstr\n";
$sth2 = $dbh->Query("select * from $tables[1]")
     or warn "Query had some problem: $Msql::db_errstr\n";

$count=0;
while (@row2=$sth2->FetchRow and @row1=$sth1->FetchRow){
    $count++;
}
$count == 2  and print ("ok 13\n") or print("not ok 13\n"); 

undef ($sth2);

$count=0;
while (@row1=$sth1->FetchRow){
    $count++;
}
$count == 1 and print ("ok 14\n") or print("not ok 14\n");

$sth = $dbh->Query  ("select * from $tables[0]
     where two = 'Thomas')")
     or warn "Query had some problem: $Msql::db_errstr\n";

@row=$sth->FetchRow;
$row[2] eq "Pauline" and print ("ok 15\n") or print("not ok 15\n");

@fieldnum{@{$sth->{NAME}}} = 0..@{$sth->{NAME}}-1;
$row[$fieldnum{"one"}] eq 'Sabine' 
    and print ("ok 16\n") or print("not ok 16\n");

( $dbh1 = Connect Msql($host,"test") )
    and print("ok 17\n") 
    or print "not ok 17\n";

$dbh1->{DATABASE} eq "test" and print("ok 18\n") or print("not ok 18\n");
$dbh1->{SOCK} =~ /^\d+$/ and print("ok 19\n") or print("not ok 19\n");

$dbh1->Query("drop table $tables[1]") and print("ok 20\n") or print("not ok 20\n");

@array=$dbh1->ListDBs;
grep( /^test$/, @array ) and print("ok 21\n") or print("not ok 21\n");

@array=$dbh1->ListTables;
grep( /^$tables[0]$/, @array )  and print("ok 22\n") or print("not ok 22\n");

( $dbh2 = Connect Msql($host,"test") )
    and print("ok 23\n") 
    or die "not ok 23\n";

$dbh2->{HOST} eq $host 
    and print("ok 24\n") 
    or die "not ok 24\n";

$sth=$dbh2->Query("select one from $tables[0]");
$sth->{HOST} eq $host
    and print("ok 25\n") 
    or die "not ok 25\n";

$dbh1->Query("drop table $tables[0]");



sub create {"create table $tables[$_[0]] ( name char(40) not null, 
            num int primary key, country char(4), time real )";}
sub drop {"drop table $tables[$_[0]]";}

$C="AAAA"; $N=1;
$dbh1->Query(&create(0));
for (1..5){
    $dbh1->Insert($tables[0],$C++,$N++,$C++,rand);
    $dbh2->Insert($tables[0],$C++,$N++,$C++,rand);
}

$sth=$dbh1->Query("select * from $tables[0]");
$testseen=0;
while (@row = $sth->FetchRow){
    $testseen++;
}
$testseen==10  and print("ok 26\n") or print("not ok 26\n");
undef $sth;

for (1..4){
    $dbh1->Query(&drop(0));
    $dbh1->Query(&create(1));
    $dbh2->Query(&drop(1));
    $dbh2->Query(&create(0));
}
($dbh1->Query(&drop(0)) ) and  print("ok 27\n") or print("not ok 27\n");

